<?php

/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */
class IsgwCauses {
    /*
     * Funktion display erzeugt den Inhalt von der HTML-Seite
     */

    function display() {

        // args
        $m = $_GET['m'];
        $q = $_GET['q'];
        $start = $_GET['start'];
        $order = $_GET['order'];
        $sort = $_GET['sort'];
        include "./includes/functions.php";
        $functions = new functions();
        $name="ISGW_CAUSES_TITLE_DIS";
        include('./includes/header.php');

        // build page content
        if (isset($_POST['rest'])) {
            if (@copy("/usr/local/conf/isgw.causes", "/tmp/isgw.causes")) {
                include_once ('/usr/local/php/include/restore.Class.php');
                $dir=getcwd();
                chdir("/usr/conf");
                if (!is_dir("backup"))
                    mkdir("backup");
                copy("isgw.causes", "backup/isgw.causes");
                unlink("isgw.causes");

                if (is_file("/tmp/isgw.causes"))
                    copy("/tmp/isgw.causes", "/usr/conf/isgw.causes");
                
                $restore = new restoreConfig(0);
                if (!$restore->isgwcauses()) {
                    copy("backup/isgw.causes", "isgw.causes");
                    echo "<script>alert('Failed!!')</script>";
                }
                chdir($dir);
            } else {
                $ba = new beroAri();
                $query = $ba->delete('delete FROM isgw_causes');
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','901','503','No channel processing resources');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','902','503','No free ISDN channels');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','903','503','No resources');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','904','404','Number not in dialplan');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','905','603','Invalid number');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','906','503','No free ISDN channels (ports are down)');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','907','503','No free ANALOG ports');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','908','503','No free ANALOG ports (ports are down)');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','909','503','Failover timeout occurred');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','910','503','No free GSM ports');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','911','503','No free dialplan destination');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','912','503','ISDN timeout');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','913','503','Not Enough SIP Licenses');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','914','503','No free CAS ports');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','915','503','Call blocked by authentication server');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','916','415','RTP media offer incompatible');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISGW','917','488','T38 media offer incompatible');");
                
                
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISDN','1','404','Unallocated number');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISDN','17','486','User busy');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISDN','21','603','Call rejected');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('SIP-ISDN','ANY','486','Busy here');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-ISGW','901','17','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-ISGW','902','17','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-ISGW','903','17','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-ISGW','904','17','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-ISGW','905','17','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-SIP','404','1','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-SIP','486','17','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-SIP','603','17','');");
                $query = $ba->insert_("INSERT into isgw_causes (direction, to_cause, from_cause, sip_response_message) VALUES('ISDN-SIP','ANY','17','');");
                $ret.=Helper::activate(2, true, $_GET['m'], ACTIVATE);
            }
        }

        $causes_table = $this->dynamic_table();
        $ret .= "<script>
					function del(table,id){
						conf = confirm('" . ISGW_CAUSES_DELETE_MESSAGE_DIS . "?');
						if (conf==false)
							return false;
						else
							window.location='./misc/delete.php?m=".$_GET['m']."&id='+id+'&table='+table;
					}
				 </script>
				 <div class='modal fade bs-example-modal-lg' id='causes-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
				  <div class='modal-dialog modal-lg'>
				    <div class='modal-content'>
				      <div class='modal-header'>
					<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
					<h4 class='modal-title' id='myModalLabel'>CAUSES MAP</h4>
				      </div>
				      <div class='modal-body'>
				      </div>
				    </div>
				  </div>
				</div>
					<form name='isgw_causes' action='' method='POST' >
					<input type=hidden name=m value='" . $m . "'>
					<br>
					<div class='container table-responsive'>
					" . $causes_table .
                "</div>"
			. "<br>"
			. "<div class='text-center'>"
			. "<a href='modules/IsgwCauses/causes_popup.php' role='button' data-remote='false' data-toggle='modal' data-target='#causes-popup' class='btn btn-default'>"
			.  BUTTON_ADD . "</a>&nbsp;"
			. "<input name='rest' type='submit' class='btn btn-default' value='" . BUTTON_LOAD_DEF . "' onclick='javascript:return confirm(\"Are you sure?\");'>"
			. "</div>"
			. "</form>"
			. "<script>
			$('#causes-popup').on('show.bs.modal', function(e) {
				var link = $(e.relatedTarget);
				$('.modal-body').load(link.attr('href'));
			});
		</script>";

        //ein neues Datenbankobjekt wird erzeugt.
        $ba = new beroAri();

        //Erzeugung der Navigationsleiste.
        $query = $ba->select('SELECT * FROM isgw_causes');
        $record_count = sqlite_num_rows($query);
        $url_opts = array();
        $url_opts['sort'] = $sort;
        $url_opts['order'] = $order;
        $ret .= "<div class='text-center'>" . 
			$functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count) .
			"</div>";

        //Rückgabe: Inhalt der HTML-Seite
        return $ret;
    }

    /*
     * Funktion dynamic_table
     */

    function dynamic_table() {
        //Wenn man Änderugen von der Daten macht werden die in der Tabelle der Datenbank
        //aktualisiert
        $ba = new beroAri();

        if (isset($_POST['save']) && isset($_POST['causes'])) {
            $ba = new beroAri();
            $ba->set("causes_active", $_POST['causes']);
            $table.=Helper::activate(2, true, $_GET['m'], ACTIVATE);
        }

        require_once("./includes/lang.php");

        $columns = $ba->column_type('isgw_causes');
        $i = 0;
        foreach ($columns as $column => $type) {
            if (($column != 'id') && ($column != 'sip_response_message')) {
                $cols_name[$i] = $column;
                if ($column == "direction")
                    $column = ISGW_CAUSES_CALL_DIRECTION_DIS;
                if ($column == "to_cause")
                    $column = ISGW_CAUSES_TO_CAUSE_DIS;
                if ($column == "from_cause")
                    $column = ISGW_CAUSES_FROM_CAUSE_DIS;
                $cols .= "<th>" . $column . "</th>";
                $i++;
            }
        }

        /* Die Einträge werden von der Tabelle sip gelesen, formatiert und in einer
          Tabelle geschrieben, zusätzlich werden 2 Knöpfe eingebaut: modify und delete */
        $start = $_GET['start'];
        $page = (($start / 15) + 1);
        if (!$start)
            $start = 0;
        $id = 0;
        for ($j = 1; $j <= $page; $j++) {
            $query = $ba->select('SELECT * FROM isgw_causes ORDER BY id asc limit 15 offset ' . sqlite_escape_string($start));
            $rows = '';
            while ($entry = $ba->fetch_array($query)) {
                $rows .= "<tr>";
                $count = sqlite_num_fields($query);

                $entry['sip_response_message'] = str_replace("\r\n", "<br>", $entry['sip_response_message']);
                $dir = preg_split("/-/", $entry['direction']);
                if ($entry['sip_response_message'] != "") {
                    $rows .= "<td onmouseover=\"Tip('" . $entry['sip_response_message'] . "')\" onmouseout='UnTip()'>" . $entry['direction'] . "</td>";
                    $rows .= "<td onmouseover=\"Tip('" . $entry['sip_response_message'] . "')\" onmouseout='UnTip()'>" . $entry['from_cause'] . " (" . $dir[0] . ")</td>";
                    $rows .= "<td onmouseover=\"Tip('" . $entry['sip_response_message'] . "')\" onmouseout='UnTip()'>" . $entry['to_cause'] . " (" . $dir[1] . ")</td>";
                } else {
                    $rows .= "<td>" . $entry['direction'] . "</td>";
                    $rows .= "<td>" . $entry['from_cause'] . " (" . $dir[0] . ")</td>";
                    $rows .= "<td>" . $entry['to_cause'] . " (" . $dir[1] . ")</td>";
                }
                $id = $entry['id'];
                $rows .= "<td class='buttons'>
					<a href='modules/IsgwCauses/causes_popup.php?id=" . $entry['id'] . "' data-remote='false' data-toggle='modal' data-target='#causes-popup' class='popup_download'>
					<img src='./includes/images/modify.png' onmouseover=\"Tip('" . MOD_ISGW_CAUSES_MODIFY . "')\" onmouseout='UnTip()'>
				</a>
				&nbsp;
				<a class='popup_download' onclick=\"del('isgw_causes','" . $id . "');\">
            	    <img src='./includes/images/delete.png' onmouseover=\"Tip('" .
                        MOD_ISGW_CAUSES_DELETE . "')\" onmouseout='UnTip()'>
				</a>

				</td></tr>";
            }
        }
        $table = "<table class='table table-striped table-bordered' style='max-width:700px; margin:auto;' id='table'><tr>" . $cols . "<th></th></tr>" . $rows . "</table>";

        return $table;
    }

}

?>
